#ifndef TIMING_H
#define TIMING_H

#include <linux/fs.h>
#include <linux/kernel.h>
#include <linux/string.h>
#include <linux/uaccess.h>

#pragma pack(1)

typedef enum _spolarity_t {
	POS, /* positive */
	NEG, /* negative */
} spolarity_t;

typedef struct _mode_parameter_t {
	/* Horizontal timing. */
	unsigned long horizontal_total;
	unsigned long horizontal_display_end;
	unsigned long horizontal_sync_start;
	unsigned long horizontal_sync_width;
	spolarity_t horizontal_sync_polarity;

	/* Vertical timing. */
	unsigned long vertical_total;
	unsigned long vertical_display_end;
	unsigned long vertical_sync_start;
	unsigned long vertical_sync_height;
	spolarity_t vertical_sync_polarity;

	/* Refresh timing. */
	unsigned long pixel_clock;
	unsigned long horizontal_frequency;
	unsigned long vertical_frequency;

	/* Clock Phase. This clock phase only applies to Panel. */
	spolarity_t clock_phase_polarity;
} mode_parameter_t;

#pragma pack()

extern int lvds_channel;
extern mode_parameter_t LVDSModeTbl;

int ReadLVDSConfiguration(void);

#endif
