#ifndef __SMI_PRIV_H__
#define __SMI_PRIV_H__

#include <linux/version.h>

struct smi_mode_info {
	bool mode_config_initialized;
	struct smi_crtc *crtc;
	/* pointer to fbdev info structure */
#if RHEL_VERSION_LOWER_THAN(8, 2)
	struct smi_fbdev *gfbdev;
#endif
};

#if RHEL_VERSION_LOWER_THAN(8, 2)
struct smi_framebuffer {
	struct drm_framebuffer base;
	struct drm_gem_object *obj;
	void *vmapping;
};

struct smi_fbdev {
	struct drm_fb_helper helper;
	struct smi_framebuffer gfb;
	struct list_head fbdev_list;
	int size;
	int x1, y1, x2, y2; /* dirty rect */
	spinlock_t dirty_lock;
};
#endif

struct smi_crtc {
	struct drm_crtc base;
	u8 lut_r[256], lut_g[256], lut_b[256];
	int last_dpms;
	bool enabled;
	int crtc_index;
	int CursorOffset;
};

struct smi_mc {
	resource_size_t vram_size;
	resource_size_t vram_base;
};

#endif
